﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Text;
using System.Web.Script.Serialization;

namespace FlexBoxTest
{
    public partial class Results : System.Web.UI.Page
    {
        private DataSet1TableAdapters.EmployeesTableAdapter _EmployeeTableAdapter = null;
        private DataSet1TableAdapters.EmployeesTableAdapter Adapter
        {
            get
            {
                if (_EmployeeTableAdapter == null)
                {
                    _EmployeeTableAdapter = new FlexBoxTest.DataSet1TableAdapters.EmployeesTableAdapter();
                }
                return _EmployeeTableAdapter;
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            //q=a&p=1&s=10&contentType=application/json; charset=utf-8
            DataSet1.EmployeesDataTable etb = new DataSet1.EmployeesDataTable();
            if (Request.QueryString["q"] == null)
            {
                etb = Adapter.GetData();
            }
            else
            {
                etb = Adapter.GetDataByKey(Request.QueryString["q"].ToString());
            }

            List<FlexBoxItem> _flexList = new List<FlexBoxItem>();
            foreach (DataSet1.EmployeesRow dr in etb.Rows)
            {
                _flexList.Add(new FlexBoxItem(dr["EmployeeID"].ToString(), dr["FirstName"].ToString()));
            }
            FlexBoxResult _flexBoxResult = new FlexBoxResult(_flexList);

            JavaScriptSerializer _jss = new JavaScriptSerializer();
            StringBuilder _jsonResult = new StringBuilder();
            _jss.Serialize(_flexBoxResult, _jsonResult);

            Response.ContentType = "application/json";
            Response.Write(_jsonResult.ToString());
            Response.End();
        }
    }

    [Serializable()]
    public class FlexBoxItem
    {
        string _id = string.Empty;
        string _name = string.Empty;

        /// <summary> 
        /// get/set id of flex box item 
        /// </summary> 
        public string id
        {
            get { return _id; }
            set { _id = value; }
        }

        /// <summary> 
        /// get/set name of flex box item 
        /// </summary> 
        public string name
        {
            get { return _name; }
            set { _name = value; }
        }

        /// <summary> 
        /// constructor with id and name as parameters 
        /// </summary> 
        /// <param name="fid"></param> 
        /// <param name="fname"></param> 
        public FlexBoxItem(string flexbox_id, string flexbox_name)
        {
            _id = flexbox_id;
            _name = flexbox_name;
        }

    }

    [Serializable()]
    public class FlexBoxResult
    {
        List<FlexBoxItem> _results = null;

        /// <summary> 
        /// get/set flexbox item list 
        /// </summary> 
        public List<FlexBoxItem> results
        {
            get { return _results; }
            set { _results = value; }
        }

        /// <summary> 
        /// constructor with flexbox item list 
        /// </summary> 
        /// <param name="_list"></param> 
        public FlexBoxResult(List<FlexBoxItem> _list)
        {
            _results = _list;
        }
    } 
  
}
